/* Includes *****************************************************************/

#include "desktop.h"

/* Constants ****************************************************************/

static const int MAX_RETRIES = 50;
static const int DELAY_DEFAULT = 200;

/* Functions ****************************************************************/

BOOL wait_for_desktop()
{
	int passes;
	HDESK desktop;

	for (passes = 1;; passes++)
	{
		desktop = OpenInputDesktop(0, FALSE, MAXIMUM_ALLOWED);

		if (desktop)
		{
			CloseDesktop(desktop);
			break;
		}

		if (passes == MAX_RETRIES)
			return FALSE;

		Sleep(DELAY_DEFAULT);
	}

	return TRUE;
}

/****************************************************************************/
