/* Includes *****************************************************************/

#include "displays.h"

/* Functions ****************************************************************/

struct adapter *new_adapter()
{
	struct adapter *adapter;

	adapter = (struct adapter *)malloc(sizeof *adapter);
	memset(adapter, 0, sizeof *adapter);
	return adapter;
}

/****************************************************************************/

struct display *new_display()
{
	struct display *display;

	display = (struct display *)malloc(sizeof *display);
	memset(display, 0, sizeof *display);
	return display;
}

/****************************************************************************/

struct display_list *new_display_list()
{
	struct display_list *display_list;

	display_list = (struct display_list *)malloc(sizeof *display_list);
	memset(display_list, 0, sizeof *display_list);
	return display_list;
}

/****************************************************************************/

BOOL add_display(struct display_list *display_list, struct display *display)
{
	if (!display_list || !display)
		return FALSE;

	if (!display_list->first)
		display_list->first = display;
	else
		display_list->last->next = display;

	display_list->last = display;
	display_list->restart += display->restart;
	display_list->count++;
	return TRUE;
}

/****************************************************************************/

void delete_display_list(struct display_list *display_list)
{
	struct display *display;
	struct display *next;

	for (display = display_list->first; display; display = next)
	{
		next = display->next;

		if (display->adapter)
			free(display->adapter);

		free(display);
	}

	free(display_list);
}

/****************************************************************************/
