#ifndef DISPLAYS_H
#define DISPLAYS_H

/* Includes *****************************************************************/

#include "stdafx.h"

/* Structs ******************************************************************/

struct adapter
{
	const char *vendor;
	int id;
	int amd;
	NvPhysicalGpuHandle nvidia;
};

/****************************************************************************/

struct display
{
	int number;
	int id;
	int amd;
	NvU32 nvidia;
	BOOL restart;
	struct adapter *adapter;
	struct display *next;
};

/****************************************************************************/

struct display_list
{
	int count;
	int restart;
	struct display *first;
	struct display *last;
};

/* Functions ****************************************************************/

struct adapter *new_adapter();
struct display *new_display();
struct display_list *new_display_list();
BOOL add_display(struct display_list *, struct display *);
void delete_display_list(struct display_list *);

/****************************************************************************/

#endif
