#ifndef HOTKEYS_H
#define HOTKEYS_H

/* Includes *****************************************************************/

#include "stdafx.h"

/* Constants ****************************************************************/

#define HK_ALT		0x1
#define HK_CTRL		0x2
#define HK_SHIFT	0x4
#define HK_WIN		0x8

#define HK_LALT		0x10
#define HK_LCTRL	0x20
#define HK_LSHIFT	0x40
#define HK_LWIN		0x80

#define HK_RALT		0x100
#define HK_RCTRL	0x200
#define HK_RSHIFT	0x400
#define HK_RWIN		0x800

#define HK_MENU		0x1000

/****************************************************************************/

#define HKS_STROBING					0x1
#define HKS_STROBING_NUMPAD				0x2
#define HKS_BRIGHTNESS					0x4
#define HKS_BRIGHTNESS_NUMLOCK_ON		0x8
#define HKS_BRIGHTNESS_NUMLOCK_OFF		0x10
#define HKS_FUNCTION					0x20

#define HKS_ALL							(HKS_STROBING | HKS_STROBING_NUMPAD | HKS_BRIGHTNESS | HKS_BRIGHTNESS_NUMLOCK_ON | HKS_BRIGHTNESS_NUMLOCK_OFF | HKS_FUNCTION)
#define HKS_ALL_STROBING				(HKS_STROBING | HKS_STROBING_NUMPAD)
#define HKS_ALL_BRIGHTNESS				(HKS_BRIGHTNESS | HKS_BRIGHTNESS_NUMLOCK_ON | HKS_BRIGHTNESS_NUMLOCK_OFF)

/* Functions ****************************************************************/

BOOL disable_hotkeys(UINT);
BOOL set_hotkey_modifier(UINT);
LPCTSTR get_hotkey_text(UINT, LPCTSTR);
BOOL register_hotkeys(HWND);
BOOL flush_hotkeys();
BOOL unregister_hotkeys();

/****************************************************************************/

#endif
