/* Includes *****************************************************************/

#include "i2c_amd.h"
#include "api_amd.h"
#include "displays.h"
#include "i2c.h"

/* Functions ****************************************************************/

BOOL i2c_amd(int action, struct display *display, int delay, unsigned char address, unsigned char *data, int size)
{
	int status;
	int zero = 0;

	if (delay)
		Sleep(delay);

	if (action == I2C_READ)
		status = ADL_Display_DDCBlockAccess_Get(display->adapter->amd, display->amd, 0, 0, sizeof address, &address, &size, data);
	else if (action == I2C_WRITE)
		status = ADL_Display_DDCBlockAccess_Get(display->adapter->amd, display->amd, 0, 0, size, data, &zero, NULL);
	else
		return FALSE;

	i2c_debug(action, display, delay, address, data, size, status);

	if (status != ADL_OK)
		return FALSE;

	return TRUE;
}

/****************************************************************************/
