/* Includes *****************************************************************/

#include "i2c_nvidia.h"
#include "displays.h"
#include "i2c.h"

/* Functions ****************************************************************/

BOOL i2c_nvidia(int action, struct display *display, int delay, unsigned char address, unsigned char *data, int size)
{
	NV_I2C_INFO info = {0};
	int status;

	info.bIsDDCPort = TRUE;
	info.bIsPortIdSet = TRUE;
	info.cbSize = size - action;
	info.displayMask = display->nvidia;
	info.i2cDevAddress = address;
	info.i2cSpeed = NVAPI_I2C_SPEED_DEPRECATED;
	info.i2cSpeedKhz = NVAPI_I2C_SPEED_10KHZ;		// Speed must be 10 KHz or less to avoid transmission errors.
	info.pbData = data + action;
	info.pbI2cRegAddress = NULL;
	info.portId = 0;
	info.regAddrSize = 0;
	info.version = NV_I2C_INFO_VER2;				// NV_I2C_INFO_VER3 is broken and causes transmission errors.

	if (delay)
		Sleep(delay);

	if (action == I2C_READ)
		status = NvAPI_I2CRead(display->adapter->nvidia, &info);
	else if (action == I2C_WRITE)
		status = NvAPI_I2CWrite(display->adapter->nvidia, &info);
	else
		return FALSE;

	i2c_debug(action, display, delay, address, data, size, status);

	if (status != NVAPI_OK)
		return FALSE;

	return TRUE;
}

/****************************************************************************/
