/* Includes *****************************************************************/

#include "options.h"
#include "debug.h"
#include "hotkeys.h"
#include "icon.h"

/* Options ******************************************************************/

BOOL skip_init = FALSE;
BOOL init_only = FALSE;
BOOL start_strobed = TRUE;

/* Functions ****************************************************************/

BOOL parse_options()
{
	TCHAR path[32768];
	LPTSTR file;
	LPTSTR option;
	int index;

	if (!GetModuleFileName(NULL, path, 32768))
		return FALSE;

	file = _tcsrchr(path, _T('\\'));

	if (!file)
		file = path;

	option = _tcsrchr(file, _T('.'));

	if (option)
		*option = 0;

	_tcslwr(file);
	option = _tcstok(file, _T("-"));

	if (!option)
		return TRUE;

	while (option = _tcstok(NULL, _T("-")))
	{
		if (_tcscmp(option, _T("debug")) == 0)
		{
			set_debug_level(-1);
			continue;
		}
/*
		if (_tcscmp(option, _T("d1")) == 0)
		{
			set_debug_level(1);
			continue;
		}

		if (_tcscmp(option, _T("d2")) == 0)
		{
			set_debug_level(2);
			continue;
		}
*/
		if (_tcscmp(option, _T("hide")) == 0)
		{
			enable_notify_icon(FALSE);
			continue;
		}

		if (_tcscmp(option, _T("skip")) == 0)
		{
			skip_init = TRUE;
			continue;
		}

		if (_tcscmp(option, _T("init")) == 0)
		{
			init_only = TRUE;
			continue;
		}

		if (_tcscmp(option, _T("off")) == 0)
		{
			start_strobed = FALSE;
			continue;
		}

		if (_tcscmp(option, _T("alt")) == 0)
		{
			set_hotkey_modifier(HK_ALT);
			continue;
		}

		if (_tcscmp(option, _T("ctrl")) == 0)
		{
			set_hotkey_modifier(HK_CTRL);
			continue;
		}

		if (_tcscmp(option, _T("shift")) == 0)
		{
			set_hotkey_modifier(HK_SHIFT);
			continue;
		}

		if (_tcscmp(option, _T("win")) == 0)
		{
			set_hotkey_modifier(HK_WIN);
			continue;
		}

		if (_tcscmp(option, _T("lalt")) == 0)
		{
			set_hotkey_modifier(HK_LALT);
			continue;
		}

		if (_tcscmp(option, _T("lctrl")) == 0)
		{
			set_hotkey_modifier(HK_LCTRL);
			continue;
		}

		if (_tcscmp(option, _T("lshift")) == 0)
		{
			set_hotkey_modifier(HK_LSHIFT);
			continue;
		}

		if (_tcscmp(option, _T("lwin")) == 0)
		{
			set_hotkey_modifier(HK_LWIN);
			continue;
		}

		if (_tcscmp(option, _T("ralt")) == 0)
		{
			set_hotkey_modifier(HK_RALT);
			continue;
		}

		if (_tcscmp(option, _T("rctrl")) == 0)
		{
			set_hotkey_modifier(HK_RCTRL);
			continue;
		}

		if (_tcscmp(option, _T("rshift")) == 0)
		{
			set_hotkey_modifier(HK_RSHIFT);
			continue;
		}

		if (_tcscmp(option, _T("rwin")) == 0)
		{
			set_hotkey_modifier(HK_RWIN);
			continue;
		}

		if (option[0] == _T('k'))
		{
			for (index = 1; option[index]; index++)
			{
				switch (option[index])
				{
					case _T('0'):
						disable_hotkeys(HKS_ALL);
						break;

					case _T('1'):
						disable_hotkeys(HKS_STROBING);
						break;

					case _T('2'):
						disable_hotkeys(HKS_BRIGHTNESS);
						break;

					case _T('3'):
						disable_hotkeys(HKS_STROBING_NUMPAD);
						break;

					case _T('4'):
						disable_hotkeys(HKS_BRIGHTNESS_NUMLOCK_ON);
						break;

					case _T('5'):
						disable_hotkeys(HKS_BRIGHTNESS_NUMLOCK_OFF);
						break;

					case _T('6'):
						disable_hotkeys(HKS_FUNCTION);
						break;
				}
			}

			continue;
		}
	}

	return TRUE;
}

/****************************************************************************/
